local toc, privateData = ...
local AddonId = toc.identifier

EM.Settings = {}
EM.UI.Settings = {}

function EM.UI.Setup.Settings()

	local settingsTab = EM.UI.Settings

	settingsTab.Display = UI.CreateFrame("Texture", "SettingsDisplay", settingsTab)
		settingsTab.Display:SetPoint("TOPLEFT", settingsTab, "TOPLEFT")
		settingsTab.Display:SetPoint("BOTTOMRIGHT", settingsTab, "BOTTOMRIGHT")
		settingsTab.Display:SetTexture(AddonId, "gfx/settingsTab.png")
		settingsTab.Display:SetLayer(0)
	
	settingsDisplay = settingsTab.Display
	
	settingsTab.ckbTakeCustom = UI.CreateFrame("RiftCheckbox", "settingsCkbTakeCustom", settingsDisplay)
		settingsTab.ckbTakeCustom:SetPoint("TOPLEFT", settingsDisplay, "TOPLEFT", 15, 20)
		settingsTab.ckbTakeCustom:SetVisible(true)
		settingsTab.ckbTakeCustom:SetEnabled(true)
		settingsTab.ckbTakeCustom:EventAttach(Event.UI.Checkbox.Change,
			function()
				local state = settingsTab.ckbTakeCustom:GetChecked()
				if state then
					settingsTab.txfTakeCustom:SetVisible(true)
					settingsTab.txfTakeCustom:SetText("")
					if (#EM.Mail.List.Grid) == 0 then
						EM.UI.Inbox.btnTakeCustom:SetEnabled(false)
					else
						EM.UI.Inbox.btnTakeCustom:SetEnabled(true)
					end
				else
					settingsTab.txfTakeCustom:SetVisible(false)
					settingsTab.txfTakeCustom:SetText("")
					EM.UI.Inbox.btnTakeCustom:SetEnabled(false)
				end
			end, "settingsCkbTakeCustom_CheckBoxChange")
	
	settingsTab.txtTakeCustom = UI.CreateFrame("Text", "settingsTxtTakeCustom", settingsDisplay)
		settingsTab.txtTakeCustom:SetPoint("TOPLEFT", settingsTab.ckbTakeCustom, "TOPRIGHT", 10, -3)
		settingsTab.txtTakeCustom:SetFontSize(16)
		settingsTab.txtTakeCustom:SetFontColor(1,1,1,1)
		settingsTab.txtTakeCustom:SetText("Enable Take Custom Button (Searches Subject)")
		
	settingsTab.txfTakeCustom = UI.CreateFrame("RiftTextfield", "settingsTxfTakeCustom", settingsDisplay)
		settingsTab.txfTakeCustom:SetPoint("TOPLEFT", settingsTab.txtTakeCustom, "BOTTOMLEFT", 5, 2)
		settingsTab.txfTakeCustom:SetVisible(false)
		settingsTab.txfTakeCustom:SetHeight(20)
		settingsTab.txfTakeCustom:SetWidth(350)
		settingsTab.txfTakeCustom:SetLayer(5)
		settingsTab.txfTakeCustom:EventAttach(Event.UI.Input.Key.Up,
			function(handle, hEvent, key)
				if key == 'Return' then
					settingsTab.txfTakeCustom:SetKeyFocus(false)
				end
			end, "settingsTxfTakeCustom_KeyUp")
		settingsTab.txfTakeCustom:EventAttach(Event.UI.Input.Key.Focus.Loss,
			function()
				if settingsTab:GetVisible() == false then
					if EM.Settings.Inbox and EM.Settings.Inbox.Custom.Take.status then
						settingsTab.txfTakeCustom:SetText(EM.Settings.Inbox.Custom.Take.value)
					else
						settingsTab.txfTakeCustom:SetText("")
					end
				end
			end, "settingsTxfTakeCustom_KeyFocusLoss")
	
	settingsTab.ckbDeleteCustom = UI.CreateFrame("RiftCheckbox", "settingsCkbDeleteCustom", settingsDisplay)
		settingsTab.ckbDeleteCustom:SetPoint("TOPLEFT", settingsTab.ckbTakeCustom, "BOTTOMLEFT", 0, 50)
		settingsTab.ckbDeleteCustom:SetVisible(true)
		settingsTab.ckbDeleteCustom:SetEnabled(true)
		settingsTab.ckbDeleteCustom:EventAttach(Event.UI.Checkbox.Change,
			function()
				local state = settingsTab.ckbDeleteCustom:GetChecked()
				if state then
					settingsTab.txfDeleteCustom:SetVisible(true)
					settingsTab.txfDeleteCustom:SetText("")
					if (#EM.Mail.List.Grid) == 0 then
						EM.UI.Inbox.btnDeleteCustom:SetEnabled(false)
					else
						EM.UI.Inbox.btnDeleteCustom:SetEnabled(true)
					end
				else
					settingsTab.txfDeleteCustom:SetVisible(false)
					settingsTab.txfDeleteCustom:SetText("")
					EM.UI.Inbox.btnDeleteCustom:SetEnabled(false)
				end
			end, "settingsCkbDeleteCustom_CheckBoxChange")
	
	settingsTab.txtDeleteCustom = UI.CreateFrame("Text", "settingsTxtDeleteCustom", settingsDisplay)
		settingsTab.txtDeleteCustom:SetPoint("TOPLEFT", settingsTab.ckbDeleteCustom, "TOPRIGHT", 10, -3)
		settingsTab.txtDeleteCustom:SetFontSize(16)
		settingsTab.txtDeleteCustom:SetFontColor(1,1,1,1)
		settingsTab.txtDeleteCustom:SetText("Enable Delete Custom Button (Searches Subject)")
		
	settingsTab.txfDeleteCustom = UI.CreateFrame("RiftTextfield", "settingstxfDeleteCustom", settingsDisplay)
		settingsTab.txfDeleteCustom:SetPoint("TOPLEFT", settingsTab.txtDeleteCustom, "BOTTOMLEFT", 5, 2)
		settingsTab.txfDeleteCustom:SetVisible(false)
		settingsTab.txfDeleteCustom:SetHeight(20)
		settingsTab.txfDeleteCustom:SetWidth(350)
		settingsTab.txfDeleteCustom:SetLayer(5)
		settingsTab.txfDeleteCustom:EventAttach(Event.UI.Input.Key.Up,
			function(handle, hEvent, key)
				if key == 'Return' then
					settingsTab.txfDeleteCustom:SetKeyFocus(false)
				end
			end, "settingstxfDeleteCustom_KeyUp")
		settingsTab.txfDeleteCustom:EventAttach(Event.UI.Input.Key.Focus.Loss,
			function()
				if settingsTab:GetVisible() == false then
					if EM.Settings.Inbox and EM.Settings.Inbox.Custom.Delete.status then
						settingsTab.txfDeleteCustom:SetText(EM.Settings.Inbox.Custom.Delete.value)
					else
						settingsTab.txfDeleteCustom:SetText("")
					end
				end
			end, "settingstxfDeleteCustom_KeyFocusLoss")
	
	settingsTab.ckbDisableBags = UI.CreateFrame("RiftCheckbox", "settingsCkbDisableBags", settingsDisplay)
		settingsTab.ckbDisableBags:SetPoint("TOPLEFT", settingsTab.ckbDeleteCustom, "BOTTOMLEFT", 0, 50)
		settingsTab.ckbDisableBags:SetVisible(true)
		settingsTab.ckbDisableBags:SetEnabled(true)
		settingsTab.ckbDisableBags:EventAttach(Event.UI.Checkbox.Change,
			function()
				local state = settingsTab.ckbDisableBags:GetChecked()
				if state then
					EM.Context.Inventory:SetVisible(false)
				else
					EM.Context.Inventory:SetVisible(true)
				end
			end, "settingsCkbDisableBags_CheckBoxChange")
		
	settingsTab.txtDisableBags = UI.CreateFrame("Text", "settingsTxtDisableBags", settingsDisplay)
		settingsTab.txtDisableBags:SetPoint("TOPLEFT", settingsTab.ckbDisableBags, "TOPRIGHT", 10, -3)
		settingsTab.txtDisableBags:SetFontSize(16)
		settingsTab.txtDisableBags:SetFontColor(1,1,1,1)
		settingsTab.txtDisableBags:SetText("Disable Bag Overlay")
		
	settingsTab.ckbShowContacts = UI.CreateFrame("RiftCheckbox", "settingsCkbShowContacts", settingsDisplay)
		settingsTab.ckbShowContacts:SetPoint("TOPLEFT", settingsTab.ckbDisableBags, "BOTTOMLEFT", 0, 20)
		settingsTab.ckbShowContacts:SetVisible(true)
		settingsTab.ckbShowContacts:SetEnabled(true)
		
	settingsTab.txtShowContacts = UI.CreateFrame("Text", "settingsTxtShowContacts", settingsDisplay)
		settingsTab.txtShowContacts:SetPoint("TOPLEFT", settingsTab.ckbShowContacts, "TOPRIGHT", 10, -3)
		settingsTab.txtShowContacts:SetFontSize(16)
		settingsTab.txtShowContacts:SetFontColor(1,1,1,1)
		settingsTab.txtShowContacts:SetText("Automatically Open Contacts")
	
	settingsTab.btnSaveSettings = UI.CreateFrame("RiftButton", "settingsSaveSettings", settingsDisplay)
		settingsTab.btnSaveSettings:SetText("Save Settings")
		settingsTab.btnSaveSettings:SetPoint("BOTTOMCENTER", settingsDisplay, "BOTTOMCENTER", 0, 2)
		settingsTab.btnSaveSettings:SetEnabled(true)
		settingsTab.btnSaveSettings:EventAttach(Event.UI.Button.Left.Press,
			function()
				EM.UI.Settings.txfDeleteCustom:SetKeyFocus(true)
				EM.UI.Settings.txfDeleteCustom:SetKeyFocus(false)
				EM.Settings = {}
				EM.Settings.Inbox = {}
				EM.Settings.Contacts = {}
				EM.Settings.Inventory = {}
				EM.Settings.Inbox.Custom = {}
				EM.Settings.Inbox.Custom.Take = {
					status = settingsTab.ckbTakeCustom:GetChecked(), 
					value = settingsTab.txfTakeCustom:GetText()
				}
				EM.Settings.Inbox.Custom.Delete = {
					status = settingsTab.ckbDeleteCustom:GetChecked(), 
					value = settingsTab.txfDeleteCustom:GetText()
				}
				EM.Settings.Inventory.Disable = {
					status = settingsTab.ckbDisableBags:GetChecked()
				}
				EM.Settings.Contacts.AutoOpen = {
					status = settingsTab.ckbShowContacts:GetChecked()
				}
				EasyMailCharacterTable = EM.Settings
			end, "settingsSaveSettings_LeftPress")
	
	if EasyMailCharacterTable and next(EasyMailCharacterTable) ~= nil then
		if EasyMailCharacterTable.Inbox.Custom.Take.status then
			settingsTab.ckbTakeCustom:SetChecked(true)
			settingsTab.txfTakeCustom:SetText(EasyMailCharacterTable.Inbox.Custom.Take.value)
		end
		if EasyMailCharacterTable.Inbox.Custom.Delete.status then
			settingsTab.ckbDeleteCustom:SetChecked(true)
			settingsTab.txfDeleteCustom:SetText(EasyMailCharacterTable.Inbox.Custom.Delete.value)
		end
		if EasyMailCharacterTable.Inventory and EasyMailCharacterTable.Inventory.Disable.status then
			settingsTab.ckbDisableBags:SetChecked(true)
		end
		if EasyMailCharacterTable.Contacts and EasyMailCharacterTable.Contacts.AutoOpen.status then
			settingsTab.ckbShowContacts:SetChecked(true)
		end
	end
	
	EM.Created.Settings = true
	
end